/*======================================================================
	main.c
			Copyright 2002 Igarashi
======================================================================*/
/*======================================================================
@{t@C̒쌠͍ҁi炵jɑ܂Ap҂̏펯ƐӔC
͈͂ɂāARɎgp /  / zt / 邱Ƃł܂B̍ہA
߂KvȂ΁ACeB̗ނؕKv܂B

@{t@C͖ۏ؂łB{t@CgpʂɂāA҂͈؂
ӔC𕉂Ȃ̂Ƃ܂B
======================================================================*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#define	__DOS_INLINE__
#include	<sys/dos.h>
#define	__IOCS_INLINE__
#include	<sys/iocs.h>
#include	<network.h>
#include	<socket.h>
#include	"nwsub.h"
#include	"dhcp.h"

/* ۑp[NiCɏ풓j */
/* tsrarea.sƓe킹邱 */
typedef struct {
	char			magic[64];			/* 풓`FbNp */
	unsigned long	startat;			/* IPAhXݒ莞̃}VNԁibj */
	unsigned long	leasetime;			/* [Xԁibj */
	unsigned long	renewtime;			/* XVJn^C}ibj */
	unsigned long	rebindtime;			/* ČJn^C}ibj */
	unsigned long	me;					/* IPAhX */
	unsigned long	server;				/* DHCPT[oIPAhX */
	unsigned long	gateway;			/* ftHgQ[gEFC */
	unsigned long	dns[256 / 4 - 1];	/* DNST[oAhX */
} tsrarea;

extern tsrarea	g_tsrarea;
extern void		g_keepst, g_magic, g_keeped;
static unsigned long	g_subnetmask;
static char			g_domainname[256];
static char	g_devname[] = "/dev/en0";
static char	g_ifname[] = "en0";
static eaddr	g_macaddr;
static int		g_sock_s = -1, g_sock_r = -1;
static int		g_verbose = 0;

enum e_errno {
	NOERROR,
	ERR_NODEVICE,
	ERR_SOCKET,
	ERR_CONNECT,
	ERR_BIND,
	ERR_TIMEOUT,
	ERR_NAK,
	ERR_NOYIADDR,
	ERR_NOLEASETIME,
	ERR_NOSID,
	ERR_NOTKEPT,
	ERR_ALREADYKEPT,
};

static char g_title[] =
	"idhcpc.x - C`LDHCPNCAg - version 0.11 Copyright 2002,03 Igarashi\n";

static char g_usgmes[] =
	"Usage: idhcpc [options]\n"
	"Options:\n"
	"\t-r, --release\t\tRtBM[Vj\n"
	"\t-l, --print-lease-time\tc胊[XԂ\\n"
	"\t-v, --verbose\t\tڍו\[h\n";

static char	*g_errmes[] = {
	"",
	"lbg[NfoCXCXg[Ă܂.",
	"\Pbg쐬ł܂.",
	"DHCPT[o|[gւ̐ڑɎs܂.",
	"DHCPNCAg|[gւ̐ڑɎs܂.",
	"^CAEgł.",
	"DHCPT[ovۂ܂.",
	"IPAhX擾ł܂ł.",
	"[XԂ擾ł܂ł.",
	"DHCPT[oIPAhX擾ł܂.",
	"idpcpcNĂ܂.",
	"idpcpc͂łɋNĂ܂.",
};
static char g_keepmes[] =
	"RtBM[V܂.\n";

static char g_removemes[] =
	"RtBM[Vj܂.\n";

static int try_to_keep(int);
static int try_to_release(int);
static int try_to_print(int);
static void print_lease_time(unsigned long, unsigned long);
static int prepare_discover(struct sockaddr_in *);
static int discover_dhcp_server(unsigned long *, unsigned long *, struct sockaddr_in *);
static int request_to_dhcp_server(tsrarea *, unsigned long *, char *, unsigned long, unsigned long, struct sockaddr_in *);
static int send_and_receive(dhcp_msg *, struct sockaddr_in *, unsigned long, unsigned long, int);
static int fill_tsrarea(tsrarea *, unsigned long *, char *, dhcp_msg *);
static void close_sockets(void);
static int release_config(void);
static void iface_when_discover(char *);
static void iface_when_request(char *);
static void iface_when_release(char *);
static void delaysec(int);
static void put_error(int);
static void put_progress(void);
extern int keepchk(struct _mep *, size_t, struct _mep **);

/* ================================================================

	C

   ================================================================ */
int main(int argc, char *argv[])
{
	int	i;
	int	errno;
	int	rflag = 0, lflag = 0;
	int	keepflag;
	struct _mep	*pmep;

	printf(g_title);

	/* IvV */
	{
		int	argerr = 0;

		for (i = 1; i < argc; i++) {
			if ((!strcmp(argv[i], "-r")) || (!strcmp(argv[i], "--release"))) {
				rflag = 1;
			} else if ((!strcmp(argv[i], "-l")) || (!strcmp(argv[i], "--print-lease-time"))) {
				lflag = 1;
			} else if ((!stricmp(argv[i], "-v")) || (!strcmp(argv[i], "--verbose"))) {
				g_verbose = 1;
			} else {
				argerr = 1;
				break;
			}
		}
		if (argerr || (rflag && lflag)) {	/* -r-p͓włȂ */
			printf(g_usgmes);
			return EXIT_FAILURE;
		}
	}

	/* ŏ풓`FbNĂ */
	keepflag = keepchk((struct _mep *)((void *)_dos_getpdb() - sizeof(struct _mep)),
						&g_magic - &g_keepst, &pmep);
	if (keepflag) {
		/* 풓ɕۑĂO[o[N֓]Ă */
		memcpy(
			&g_tsrarea,
			(void *)pmep + sizeof(struct _mep) + sizeof(struct _psp),
			sizeof(g_tsrarea));
	}

	if (rflag) {
		/* 풓 */
		if ((errno = try_to_release(keepflag)) != NOERROR) {
			put_error(errno);
			return EXIT_FAILURE;
		} else {
			_dos_mfree((void *)pmep + sizeof(struct _mep));	/* 풓 */
			printf(g_removemes);
		}
	}
	else if (lflag) {
		/* [Xԕ\ */
		if ((errno = try_to_print(keepflag)) != NOERROR) {
			put_error(errno);
			return EXIT_FAILURE;
		}
	} else {
		/* 풓 */
		if ((errno = try_to_keep(keepflag)) != NOERROR) {
			put_error(errno);
			return EXIT_FAILURE;
		} else {
			printf(g_keepmes);
			print_lease_time(g_tsrarea.leasetime, g_tsrarea.startat);
			_dos_keeppr(&g_keeped - &g_keepst, 0);	/* 풓I */
		}
	}

	return EXIT_SUCCESS;
}

/* ================================================================

	풓

	in:		keepflag	풓tO
	out:	G[R[h

   ================================================================ */
static int try_to_keep(int keepflag)
{
	int	errno;
	struct sockaddr_in	inaddr_s;
	unsigned long	me;
	unsigned long	server;

	while (1) {
		if (keepflag) {
			errno = ERR_ALREADYKEPT;	/* łɏ풓Ă */
			break;
		}
		if ((errno = prepare_discover(&inaddr_s)) != NOERROR) break;
		if ((errno = discover_dhcp_server(
						&me,
						&server,
						&inaddr_s)) != NOERROR) break;
		if ((errno = request_to_dhcp_server(
						&g_tsrarea,
						&g_subnetmask,
						g_domainname,
						me,
						server,
						&inaddr_s)) != NOERROR) break;
		break;
	}

	close_sockets();

	return errno;
}

/* ================================================================

	풓

	in:		keepflag	풓tO
	out:	G[R[h

   ================================================================ */
static int try_to_release(int keepflag)
{
	int	errno;

	while (1) {
		if (!keepflag) {
			errno = ERR_NOTKEPT;	/* 풓ĂȂ */
			break;
		}
		if ((errno = release_config()) != NOERROR) break;
		break;
	}

	close_sockets();

	return errno;
}

/* ================================================================

	c胊[Xԕ\

	in:		keepflag	풓tO
	out:	G[R[h

   ================================================================ */
static int try_to_print(int keepflag)
{
	int	errno;

	while (1) {
		if (!keepflag) {
			errno = ERR_NOTKEPT;
			break;
		}
		print_lease_time(g_tsrarea.leasetime, g_tsrarea.startat);
		errno = NOERROR;
		break;
	}

	return errno;
}

/* ================================================================

	c胊[Xԕ\C

	in:		leasetime	iŚj[Xԁibj
			startat		IPAhXݒ莞̃}VNԁibj

   ================================================================ */
static void print_lease_time(unsigned long leasetime, unsigned long startat)
{
	int	rest, rest_h, rest_m, rest_s;

	if (leasetime == 0xffffffff) {
		printf("[XԂ͖ł.\n");
	} else {
		rest = (int)leasetime - (_iocs_ontime() / 100 - (int)startat);
		rest_s = rest % 60;
		rest /= 60;
		rest_m = rest % 60;
		rest_h = rest / 60;
		printf("c胊[XԂ");
		if (rest_h) printf(" %d ", rest_h);
		if (rest_h) printf(" %d ", rest_m);
		printf(" %d b ł.\n", rest_s);
	}
}

/* ================================================================

	DHCPDISCOVERsȎO

	in:		pinaddr_s	Mp\Pbgi[ւ̃|C^
	out:	G[R[h

   ================================================================ */
static int prepare_discover(struct sockaddr_in *pinaddr_s)
{
	/* MACAhX擾 */
	if (!get_mac_address(&g_macaddr, g_devname)) {
		return ERR_NODEVICE;
	}
	/* INIT̃lbg[NC^tF[Xݒ */
	iface_when_discover(g_ifname);

	/* MpUDP\Pbg쐬 */
	if ((g_sock_s = create_udp_socket()) < 0) {
		return ERR_SOCKET;
	}
	/* MpUDP\Pbg쐬 */
	if ((g_sock_r = create_udp_socket()) < 0) {
		return ERR_SOCKET;
	}
	/* DHCPT[o|[gi67jɐڑ */
	if (connect2(pinaddr_s, g_sock_s, DHCP_SERVER_PORT, DHCP_LIMITEDBCAST) < 0) {
		return ERR_CONNECT;
	}
	/* DHCPNCAg|[gi68jɐڑ */
	if (bind2(g_sock_r, DHCP_CLIENT_PORT, 0) < 0) {
		return ERR_BIND;
	}

	return NOERROR;
}

/* ================================================================

	DHCPDISCOVER𔭍sDHCPOFFERM

	in:		pme			vIPAhXi[ւ̃|C^
			pserver		DHCPT[oIPAhXi[ւ̃|C^
			pinaddr_s	Mp\Pbgi[ւ̃|C^
	out:	G[R[h

   ================================================================ */
static int discover_dhcp_server(unsigned long *pme, unsigned long *pserver, struct sockaddr_in *pinaddr_s)
{
	int			ret;
	dhcp_msg	msg;

	if ((ret = send_and_receive(&msg, pinaddr_s, 0, 0, DHCPDISCOVER)) != NOERROR) {
		return ret;
	}

	if ((*pme = dhcp_get_yiaddr(&msg)) == 0) {		/* vIPAhX */
		return ERR_NOYIADDR;
	}
	if (dhcp_get_serverid(&msg, pserver) == NULL) {	/* T[oID */
		return ERR_NOSID;
	}

	return NOERROR;
}

/* ================================================================

	DHCPREQUEST𔭍sDHCPACKM

	in:		ptsrarea	RtBM[Vi[ւ̃|C^
			pmask		Tulbg}XNi[ւ̃|C^
			pdomain		hCi[ւ̃|C^
			me			vIPAhX
			server		DHCPT[oIPAhX
			pinaddr_s	Mp\Pbgi[ւ̃|C^
	out:	G[R[h

   ================================================================ */
static int request_to_dhcp_server(tsrarea *ptsrarea, unsigned long *pmask, char *pdomain, unsigned long me, unsigned long server, struct sockaddr_in *pinaddr_s)
{
	int			ret;
	dhcp_msg	msg;

	if ((ret = send_and_receive(&msg, pinaddr_s, me, server, DHCPREQUEST)) != NOERROR) {
		return ret;
	}

	/* MʂvIPAhX / T[oID̑𔲂o */
	if ((ret = fill_tsrarea(ptsrarea, pmask, pdomain, &msg)) != NOERROR) {
		return ret;
	}

	/* ̎_ł̃}VNԂoĂ */
	g_tsrarea.startat = (unsigned long)(_iocs_ontime() / 100);

	/* REQUEST̃lbg[NC^tF[Xݒ */
	iface_when_request(g_ifname);

	return NOERROR;
}

/* ================================================================

	DHCPbZ[WM / M

	in:		prmsg		DHCPbZ[Wobt@i[ւ̃|C^
			pinaddr_s	Mp\Pbgi[ւ̃|C^
			me			vIPAhX
			server		DHCPT[oIPAhX
			msgtype_s	DHCPbZ[W^CviDHCPDISCOVER or DHCPREQUESTj
	out:	G[R[h

   ================================================================ */
static int send_and_receive(dhcp_msg *prmsg, struct sockaddr_in *pinaddr_s, unsigned long me, unsigned long server, int msgtype_s)
{
	dhcp_msg		smsg;			/* DHCPbZ[Wobt@iMpj */
	struct sockaddr_in	inaddr_r;
	unsigned char	msgtype_r;		/* Mf[^̃bZ[W^Cv */
	int				wait = 4;		/* ^CAEgb */
	int				timeout = 0;	/* ^CAEgtO */
	int				i;				/* [vJE^ */

	/* ő4điv5񑗐Mj */
	for (i=0; i< 5; i++) {
		unsigned long	xid;			/* gUNVID */
		unsigned short	secs;			/* Ňoߎԁibj */
		int				endat;			/* ^CAEgp */

		if (g_verbose) {
			if (i > 0) printf(" gC܂i%dځj...\n", i);
			fflush(stdout);
		}
		/* ================================
			bZ[WM
		   ================================ */
		xid = random();		/* gUNVIDݒ */
		secs = (unsigned short)(_iocs_ontime() / 100);
		switch (msgtype_s) {
			case DHCPDISCOVER:
				dhcp_make_dhcpdiscover(&smsg, &g_macaddr, xid, secs);
				break;
			case DHCPREQUEST:
				dhcp_make_dhcprequest(&smsg, me, server, &g_macaddr, xid, secs);
				break;
			default:
				break;
		}
		if (g_verbose) {
			dhcp_print(&smsg);
			printf("DHCPT[o|[gi67j֑M ...\n");
			fflush(stdout);
		}
		sendto(g_sock_s, (char *)&smsg, sizeof(smsg), 0, (char *)pinaddr_s, sizeof(*pinaddr_s));
/*		while (socklen(g_sock_s, 1)) ;*/	/* M҂ */

		/* ================================
			bZ[WM
		   ================================ */
		if (g_verbose) {
			printf(
				"DHCPNCAg|[gi68jM. "
				"%dbɃ^CAEg܂ ...", wait);
			fflush(stdout);
		}

		/* ^CAEg~bgݒ */
		/* 4, 8, 16, 32, 64 } 1b炢 */
		endat = _iocs_ontime() + (wait - 1) * 100 + random() % 200;
		timeout = 0;
		while (1) {
			int	len = sizeof(inaddr_r);

			if (_iocs_ontime() > endat) {
				timeout = 1;
				break;
			}
			if (!socklen(g_sock_r, 0)) {
				if (g_verbose) put_progress();
				continue;
			}
			recvfrom(g_sock_r, (char *)prmsg, sizeof(*prmsg), 0, (char *)&inaddr_r, &len);
			if (!dhcp_isreply(prmsg, xid, &msgtype_r)) continue;
			if (msgtype_s == DHCPDISCOVER) {
				if (msgtype_r == DHCPOFFER) break;	/* M */
			} else if (msgtype_s == DHCPREQUEST) {
				if ((msgtype_r == DHCPACK) || (msgtype_r == DHCPNAK)) break;	/* M */
			}
		}
		if (!timeout) {
			if (g_verbose) {
				printf(" done.\n");
				dhcp_print(prmsg);
			}
			break;		/* MŃ[vEo */
		}
		if (g_verbose) printf(" ^CAEgł.");
		wait <<= 1;
	}

	if (timeout) return ERR_TIMEOUT;	/* ^CAEg */

	if (msgtype_s == DHCPREQUEST) {
		if (msgtype_r == DHCPNAK) return ERR_NAK;
	}

	return NOERROR;
}

/* ================================================================

	RtBM[VZ[u

	in:		ptsrarea	RtBM[Vi[ւ̃|C^
			pmask		Tulbg}XNi[ւ̃|C^
			pdomain		hCi[ւ̃|C^
			pmsg		DHCPOFFER܂DHCPACKŎMDHCPbZ[W
	out:	G[R[h

   ================================================================ */
static int fill_tsrarea(tsrarea *ptsrarea, unsigned long *pmask, char *pdomain, dhcp_msg *pmsg)
{
	if ((ptsrarea->me = dhcp_get_yiaddr(pmsg)) == 0) {		/* vIPAhX */
		return ERR_NOYIADDR;
	}
	if (dhcp_get_serverid(pmsg, &ptsrarea->server) == NULL) {	/* T[oID */
		return ERR_NOSID;
	}
	ptsrarea->gateway = 0;						/* ftHgQ[gEFC */
	dhcp_get_defroute(pmsg, &ptsrarea->gateway);
	dhcp_get_dns(pmsg, ptsrarea->dns);			/* hCT[oizj */
	if (dhcp_get_leasetime(pmsg, &ptsrarea->leasetime) == NULL) {	/* [X */
		/* [XԂnȂIH */
		return ERR_NOLEASETIME;
	}
	ptsrarea->renewtime = 0;					/* XV */
	dhcp_get_renewtime(pmsg, &ptsrarea->renewtime);
	if (ptsrarea->renewtime == 0) {
		ptsrarea->renewtime = ptsrarea->leasetime / 2;
	}
	ptsrarea->rebindtime = 0;					/* Č */
	dhcp_get_rebindtime(pmsg, &ptsrarea->rebindtime);
	if (ptsrarea->rebindtime == 0) {
		ptsrarea->rebindtime = ptsrarea->leasetime * 857 / 1000;
	}
	*pmask = 0;							/* Tulbg}XN */
	dhcp_get_subnetmask(pmsg, pmask);
	dhcp_get_domainname(pmsg, pdomain);	/* hC */

	return NOERROR;
}

/* ================================================================

	I[vς݂̃\PbgׂăN[Y

   ================================================================ */
static void close_sockets(void)
{
	if (g_sock_s != -1) {
		close_s(g_sock_s);
		g_sock_s = -1;
	}
	if (g_sock_r != -1) {
		close_s(g_sock_r);
		g_sock_r = -1;
	}
}

/* ================================================================

	DHCPRELEASE𔭍sălbg[NC^tF[X

	out:	errno	G[R[h

   ================================================================ */
static int release_config(void)
{
	dhcp_msg		msg;			/* DHCPbZ[Wobt@ */
	struct sockaddr_in	inaddr_s;

	/* MACAhX擾 */
	if (!get_mac_address(&g_macaddr, g_devname)) {
		return ERR_NODEVICE;
	}

	/* MpUDP\Pbg쐬 */
	if ((g_sock_s = create_udp_socket()) < 0) {
		return ERR_SOCKET;
	}
	/* DHCPT[o|[gi67jɐڑ */
	if (connect2(&inaddr_s, g_sock_s, DHCP_SERVER_PORT, g_tsrarea.server) < 0) {
		return ERR_CONNECT;
	}

	/* ================================
		DHCPRELEASEbZ[WM
	   ================================ */
	dhcp_make_dhcprelease(&msg, g_tsrarea.me, g_tsrarea.server, &g_macaddr, random());
	if (g_verbose) {
		dhcp_print(&msg);
		printf("DHCPT[o|[gi67j֑M ...\n");
		fflush(stdout);
	}
	sendto(g_sock_s, (char *)&msg, sizeof(msg), 0, (char *)&inaddr_s, sizeof(inaddr_s));
/*	while (socklen(g_sock_s, 1)) ;*/

	iface_when_release(g_ifname);

	return NOERROR;
}

/* ================================================================

	DHCPDISCOVER̃lbg[NC^tF[Xݒ

	in:		ifname	C^tF[Xi"en0"j

   ================================================================ */
static void iface_when_discover(char *ifname)
{
	iface	*p, *p0;

	if ((p0 = iface_lookupn(ifname)) != NULL) {
		p = p0;
	} else {
		p = get_new_iface(ifname);
	}
	p->my_ip_addr = 0;
	p->broad_cast = DHCP_LIMITEDBCAST;
	p->flag |= IFACE_UP | IFACE_BROAD;
	if (p0 == NULL) {
		link_new_iface(p);
	}
/*	delaysec(150);
*/}

/* ================================================================

	DHCPREQUEST̃lbg[NC^tF[Xݒ

	in:		ifname	C^tF[Xi"en0"j

   ================================================================ */
static void iface_when_request(char *ifname)
{
	iface	*p = iface_lookupn(ifname);

	p->my_ip_addr = g_tsrarea.me;
	p->net_mask = g_subnetmask;
	p->broad_cast = (p->my_ip_addr & g_subnetmask) | ~g_subnetmask;
	p->flag |= IFACE_UP;

	{
		unsigned long	*p = g_tsrarea.dns, addr;

		while ((addr = *p++)) {
			dns_add((long)addr);
		}
	}
	if (strcmp(g_domainname, "")) {
		set_domain_name(g_domainname);
	}
	if (g_tsrarea.gateway) {
		route	*def;
		rt_top(&def);
		def->gateway = (long)g_tsrarea.gateway;
	}
/*	delaysec(150);
*/}

/* ================================================================

	DHCPRELEASEs̃lbg[NC^tF[X̒덇킹

	in:		ifname	C^tF[Xi"en0"j

   ================================================================ */
static void iface_when_release(char *ifname)
{
	iface	*p = iface_lookupn(ifname);

	if (p->flag & IFACE_UP) {
		p->stop(p);		/* sȂƊ荞݂Ȃ炵 */
		delaysec(150);	/* EFCg܂ȂƂ܂݂ */
	}
	p->my_ip_addr = 0;
	p->net_mask = 0;
	p->broad_cast = 0;
	p->flag &= ~(IFACE_UP | IFACE_BROAD);

	{
		unsigned long	*p = g_tsrarea.dns, addr;

		while ((addr = *p++)) {
			dns_drop((long)addr);
		}
	}
	set_domain_name("");
	if (g_tsrarea.gateway) {
		route	*def;
		rt_top(&def);
		def->gateway = 0;
	}
}

/* ================================================================

	1/100bPʂŃEFCg܂

	in:		tm	EFCgJEgij

   ================================================================ */
static void delaysec(int tm)
{
	int	endat = _iocs_ontime() + tm;

	while (endat > _iocs_ontime()) ;
}

/* ================================================================

	G[bZ[W\

	in:		errno	G[R[h

   ================================================================ */
static void put_error(int errno)
{
	printf("G[܂. %s\n", g_errmes[errno]);
	fflush(stdout);
}

/* ================================================================

	C`LvOX\

   ================================================================ */
static void put_progress(void)
{
	static int	ontime0 = 0;
	int		ontime = _iocs_ontime();
	if (ontime - ontime0 >= 50) {
		printf(".");
		fflush(stdout);
		ontime0 = ontime;
	}
}

